"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.components = exports.componentsPlugin = void 0;
const vuepress_shared_1 = require("@mr-hope/vuepress-shared");
const utils_1 = require("@vuepress/utils");
const vuepress_plugin_sass_palette_1 = require("vuepress-plugin-sass-palette");
const locales_1 = require("./locales");
const availableComponents = ["Badge"];
const componentsPlugin = (options, app) => {
    (0, vuepress_plugin_sass_palette_1.useSassPalettePlugin)(app, { id: "hope" });
    return {
        name: "@mr-hope/vuepress-plugin-components",
        alias: Object.fromEntries(availableComponents.map((item) => {
            var _a;
            return [
                `@${item}`,
                ((_a = options.components) === null || _a === void 0 ? void 0 : _a.includes(item))
                    ? utils_1.path.resolve(__dirname, `../client/components/${item}.js`)
                    : vuepress_shared_1.noopModule,
            ];
        })),
        define: {
            BACK_TO_TOP_THRESHOLD: options.backToTopThreshold || 300,
            BACK_TO_TOP_LOCALES: (0, vuepress_shared_1.getLocales)(app, locales_1.backToTopLocales, options.backToTopLocales),
        },
        onInitialized: (app) => {
            (0, vuepress_shared_1.addViteSsrNoExternal)(app, [
                "@mr-hope/vuepress-shared",
                "@mr-hope/vuepress-plugin-components",
            ]);
            (0, vuepress_shared_1.addViteOptimizeDepsExclude)(app, "@mr-hope/vuepress-plugin-components");
            if (options.backToTop)
                (0, vuepress_shared_1.addViteOptimizeDepsInclude)(app, "lodash.debounce");
        },
        clientAppEnhanceFiles: utils_1.path.resolve(__dirname, "../client/appEnhance.js"),
        clientAppRootComponentFiles: options.backToTop
            ? utils_1.path.resolve(__dirname, "../client/root-components/BackToTop.js")
            : undefined,
    };
};
exports.componentsPlugin = componentsPlugin;
const components = (options) => ["@mr-hope/components", options];
exports.components = components;
//# sourceMappingURL=plugins.js.map